void SCI0_RXI_func(){
  volatile unsigned char *SMR0,*BRR0,*SCR0,*TDR0,*SSR0,*RDR0,*SDCR0;
  char recv_char;

  SMR0 = (unsigned char *)0xFFFF81A0;
  BRR0 = SMR0+1;
  SCR0 = SMR0+2;
  TDR0 = SMR0+3;
  SSR0 = SMR0+4;
  RDR0 = SMR0+5;
  SDCR0 = SMR0+6;

  recv_char = *RDR0;
  *SSR0 &= ~(1<<6);
  
  // $B%(%3!<%P%C%/(B
  while((*SSR0 & (1<<7)) == 0){}
  *TDR0 = recv_char;
  *SSR0 = *SSR0 & ~(1<<7);
}


int main(){
  volatile unsigned short *io_port_E;
  volatile unsigned short *PECRL1, *PEIORL;
  volatile int i,j;

  volatile unsigned short *PACRL2;
  volatile unsigned short *IPRF;
  volatile unsigned char *SMR0,*BRR0,*SCR0,*TDR0,*SSR0,*RDR0,*SDCR0;
  volatile unsigned short *MSTCR1;
  char message[] = "Message from Serial Port0.\r\n";
  volatile unsigned int *virtualVBR;


  // LED$B$NE@LG(B
  PECRL1 = (unsigned short *)0xFFFF83B8;
  PEIORL = (unsigned short *)0xFFFF83B4;
  io_port_E = (unsigned short *)0xFFFF83B0;

  *PECRL1 &= 0x0FFF;
  *PEIORL |= (1<<15);
  *io_port_E = (1<<15);

  for(j=0;j<20;j++){
    for(i=0;i<1000000;i++);
    
    *io_port_E = *io_port_E & 0x7FFF;

    for(i=0;i<1000000;i++);

    *io_port_E = *io_port_E | (1<<15);

  }

  // $B%7%j%"%k%]!<%H$r%"%/%F%#%V$K$9$k!#(BSCI1$B$r;HMQ(B
  virtualVBR = (unsigned int *)0xFFFFFFFC;
  *virtualVBR = 0xFFFFE000;

  IPRF = (unsigned short *)0xFFFF8352;

  MSTCR1 = (unsigned short *)0xFFFF861C;

  PACRL2 = (unsigned short *)0xFFFF838E;

  SMR0 = (unsigned char *)0xFFFF81A0;
  BRR0 = SMR0+1;
  SCR0 = SMR0+2;
  TDR0 = SMR0+3;
  SSR0 = SMR0+4;
  RDR0 = SMR0+5;
  SDCR0 = SMR0+6;

  // SCI0$B$r%9%?%s%P%$>uBV$+$i2r=|(B
  *MSTCR1 &= ~0x1;
  // TXD0,RXD0$B$r%$%M!<%V%k(B 
  *PACRL2 = ((1<<2) | (1<<0));
  // 9600bps (CKS = 00, BRR=77)
  // $BD4JbF14|(B
  // 8bit
  // $B%Q%j%F%#$J$7(B
  // Stop$B%S%C%H(B1$B%S%C%H(B
  *SCR0 = 0x0;
  *SMR0 = 0x0;
  *BRR0 = 77;
  for(i=0;i<(*BRR0*1000);i++){}
  // $B<u?.3d$j9~$_5v2D!"Aw?.5v2D!"<u?.5v2D(B
  *SCR0 = ((1<<6)|(1<<5)|(1<<4));
  *IPRF |= (0xF<<4);

  i=0;
  while(message[i] != '\0'){
    // $BAw?.%P%C%U%!$N6u$-$rBT$D(B
     while((*SSR0 & (1<<7)) == 0){}
    // $BAw?.%G!<%?=q$-9~$_(B
    *TDR0 = message[i];
    // $BAw?.3+;O(B
    *SSR0 = *SSR0 & ~(1<<7);
    i++;
  }

  while(1) {}

  return 0;

}

