// SCI1fobO|[gƂėp܂
#define DEBUG_PORT_NUM 1
#define DEBUG_BAUDRATE 19200

// [Uu[NRg[T|[gꍇ錾
#define UBC_SUPPORTED

// VAo͗p̃obt@̍őlłB
// ̃obt@TCYNUMREGBYTES*2ȏȂƂ܂B
#define BUFMAX 512

// GDBɕ񍐂郌WX^
#define NUMREGS 28

// WX^̓eL^ۂ̃TCYioCgj
// 32rbgA[LeN`̂Ƃ́A4~WX^ɂȂ܂B
#define NUMREGBYTES (NUMREGS*4)

typedef void (*Function) ();

void putDebugChar (char);
char getDebugChar (void);

enum regnames
  {
    R0, R1, R2, R3, R4, R5, R6, R7,
    R8, R9, R10, R11, R12, R13, R14,
    R15, PC, PR, GBR, VBR, MACH, MACL, SR,
    TICKS, STALLS, CYCLES, INSTS, PLR
  };

// VOi̎ވꗗ
// exceptionVectorƔrĂB
#define CPU_BUS_ERROR_VEC  9
#define DMA_BUS_ERROR_VEC 10
#define NMI_VEC           11
#define INVALID_INSN_VEC   4
#define INVALID_SLOT_VEC   6
#define TRAP_VEC          32
#define IO_VEC            33
#define USER_VEC         255

int registers[NUMREGBYTES / 4];
extern unsigned int virtualVBR;
static const char hexchars[] = "0123456789abcdef";
char remcomInBuffer[BUFMAX];
char remcomOutBuffer[BUFMAX];

extern breakpoint_address;
extern illegalinst_address;

// [Uu[NRg[̃u[N|Cg폜֐
void UBC_clr(){
  volatile unsigned short *UBARH, *UBARL, *UBAMRH, *UBAMRL, *UBBR, *UBCR;
  volatile unsigned short *MSTCR2;

  MSTCR2 = (unsigned short *)0xFFFF861E;

  UBARH = (unsigned short *)0xFFFF8600;
  UBARL = UBARH + 1;
  UBAMRH = UBARH + 2;
  UBAMRL = UBARH + 3;
  UBBR =  UBARH + 4;
  UBCR =  UBARH + 5;

  *MSTCR2 &= ~1;

  *UBARH = 0x0000;
  *UBARL = 0x0000;

  *UBAMRH = 0;
  *UBAMRL = 0;

  *UBBR = 0x0000; // CPUTCNA߃tFb`A[h
  *UBCR = 0; // u[NL  
}

// [Uu[NRg[Ƀu[N|Cgݒ肷֐
void UBC_set(unsigned int addr){
  volatile unsigned short *UBARH, *UBARL, *UBAMRH, *UBAMRL, *UBBR, *UBCR;
  volatile unsigned short *MSTCR2;

  MSTCR2 = (unsigned short *)0xFFFF861E;

  UBARH = (unsigned short *)0xFFFF8600;
  UBARL = UBARH + 1;
  UBAMRH = UBARH + 2;
  UBAMRL = UBARH + 3;
  UBBR =  UBARH + 4;
  UBCR =  UBARH + 5;

  *MSTCR2 &= ~1;

  *UBARH = (short)(((addr)>>16) & 0xFFFF);
  *UBARL = (short)((addr) & 0xFFFF);

  *UBAMRH = 0;
  *UBAMRL = 0;

  *UBBR = 0x0054; // CPUTCNA߃tFb`A[h
  *UBCR = 0; // u[NL
}

char * strcpy(char *dest, const char *src){

  while(*src != '\0'){
    *dest = *src;
    src ++;
    dest ++;
  }
  *dest = 0;
  return dest;
}

char highhex(int  x)
{
  return hexchars[(x >> 4) & 0xf];
}

char lowhex(int  x)
{
  return hexchars[x & 0xf];
}

/*
 * Routines to handle hex data
 */

static int
hex (char ch)
{
  if ((ch >= 'a') && (ch <= 'f'))
    return (ch - 'a' + 10);
  if ((ch >= '0') && (ch <= '9'))
    return (ch - '0');
  if ((ch >= 'A') && (ch <= 'F'))
    return (ch - 'A' + 10);
  return (-1);
}

/* convert the memory, pointed to by mem into hex, placing result in buf */
/* return a pointer to the last char put in buf (null) */
static char *
mem2hex (char *mem, char *buf, int count)
{
  int i;
  int ch;
  for (i = 0; i < count; i++)
    {
      ch = *mem++;
      *buf++ = highhex (ch);
      *buf++ = lowhex (ch);
    }
  *buf = 0;
  return (buf);
}

/* convert the hex array pointed to by buf into binary, to be placed in mem */
/* return a pointer to the character after the last byte written */

static char *
hex2mem (char *buf, char *mem, int count)
{
  int i;
  unsigned char ch;
  for (i = 0; i < count; i++)
    {
      ch = hex (*buf++) << 4;
      ch = ch + hex (*buf++);
      *mem++ = ch;
    }
  return (mem);
}

/**********************************************/
/* WHILE WE FIND NICE HEX CHARS, BUILD AN INT */
/* RETURN NUMBER OF CHARS PROCESSED           */
/**********************************************/
static int
hexToInt (char **ptr, int *intValue)
{
  int numChars = 0;
  int hexValue;

  *intValue = 0;

  while (**ptr)
    {
      hexValue = hex (**ptr);
      if (hexValue >= 0)
	{
	  *intValue = (*intValue << 4) | hexValue;
	  numChars++;
	}
      else
	break;

      (*ptr)++;
    }

  return (numChars);
}

/*
 * Routines to get and put packets
 */

/* scan for the sequence $<data>#<checksum>     */

char *
getpacket (void)
{
  unsigned char *buffer = &remcomInBuffer[0];
  unsigned char checksum;
  unsigned char xmitcsum;
  int count;
  char ch;

  while (1)
    {
      /* wait around for the start character, ignore all other characters */
      while ((ch = getDebugChar ()) != '$')
	;

    retry:
      checksum = 0;
      xmitcsum = -1;
      count = 0;

      /* now, read until a # or end of buffer is found */
      while (count < BUFMAX)
	{
	  ch = getDebugChar ();
          if (ch == '$')
            goto retry;
	  if (ch == '#')
	    break;
	  checksum = checksum + ch;
	  buffer[count] = ch;
	  count = count + 1;
	}
      buffer[count] = 0;
      if (ch == '#')
	{
 	  ch = getDebugChar ();
 	  xmitcsum = hex (ch) << 4;
 	  ch = getDebugChar ();
 	  xmitcsum += hex (ch);

	  if (checksum != xmitcsum)
	    {
	      putDebugChar ('-');	/* failed checksum */
	    }
	  else
	    {
	      putDebugChar ('+');	/* successful transfer */

	      /* if a sequence char is present, reply the sequence ID */
	      if (buffer[2] == ':')
		{
		  putDebugChar (buffer[0]);
		  putDebugChar (buffer[1]);

 		  return &buffer[3];
		}

	      return &buffer[0];
	    }
	}
    }
}


/* send the packet in buffer. */
static void
putpacket (unsigned char *buffer)
{
  unsigned char checksum;
  int count;
  unsigned char ch;

  /*  $<packet info>#<checksum>. */
  do
    {
      putDebugChar('$');
      checksum = 0;
      count = 0;

      while (ch = buffer[count])
	{
	  putDebugChar(ch);
	  checksum += ch;
	  count += 1;
	}

      putDebugChar('#');
      putDebugChar(hexchars[checksum >> 4]);
      putDebugChar(hexchars[checksum & 0xf]);

    }
  while (getDebugChar() != '+');
}

// GDBɒʒmVOiԂ֐B
static int
computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case INVALID_INSN_VEC:
      sigval = 4;
      break;
    case INVALID_SLOT_VEC:
      sigval = 4;
      break;
    case CPU_BUS_ERROR_VEC:
      sigval = 10;
      break;
    case DMA_BUS_ERROR_VEC:
      sigval = 10;
      break;
    case NMI_VEC:
      sigval = 2;
      break;
    case TRAP_VEC:
    case USER_VEC:
      sigval = 5;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

void
gdb_handle_exception (int exceptionVector)
{
  int sigval;
  int addr, length;
  char *ptr;
  int i;

  /* reply to host that an exception has occurred */
  sigval = computeSignal (exceptionVector);
  remcomOutBuffer[0] = 'S';
  remcomOutBuffer[1] = highhex(sigval);
  remcomOutBuffer[2] = lowhex (sigval);
  remcomOutBuffer[3] = 0;

  putpacket (remcomOutBuffer);

  remcomOutBuffer[0] = 0;
  
  while (1)
    {
      remcomOutBuffer[0] = 0;
      ptr = getpacket ();


      switch (*ptr++)
	{
	case 'H':
	case '!':
	  strcpy (remcomOutBuffer, "OK");
	  break;
	case '?':
	  remcomOutBuffer[0] = 'S';
	  remcomOutBuffer[1] = highhex (sigval);
	  remcomOutBuffer[2] = lowhex (sigval);
	  remcomOutBuffer[3] = 0;
	  break;
	case 'g':		/* return the value of the CPU registers */
	  mem2hex ((char *) registers, remcomOutBuffer, NUMREGBYTES);
	  break;
	case 'G':		/* set the value of the CPU registers - return OK */
	  hex2mem (ptr, (char *) registers, NUMREGBYTES);
	  strcpy (remcomOutBuffer, "OK");
	  break;

	  /* mAA..AA,LLLL  Read LLLL bytes at address AA..AA */
	case 'm':
	  /* TRY, TO READ %x,%x.  IF SUCCEED, SET PTR = 0 */
	  if (hexToInt (&ptr, &addr))
	    if (*(ptr++) == ',')
	      if (hexToInt (&ptr, &length))
		{
		  ptr = 0;
		  mem2hex ((char *) addr, remcomOutBuffer, length);
		}
	  if (ptr)
	    strcpy (remcomOutBuffer, "E01");
	  break;
	  /* MAA..AA,LLLL: Write LLLL bytes at address AA.AA return OK */
	case 'M':
	  /* TRY, TO READ '%x,%x:'.  IF SUCCEED, SET PTR = 0 */
	  if (hexToInt (&ptr, &addr))
	    if (*(ptr++) == ',')
	      if (hexToInt (&ptr, &length))
		if (*(ptr++) == ':')
		  {
		    hex2mem (ptr, (char *) addr, length);
		    ptr = 0;
		    strcpy (remcomOutBuffer, "OK");
		  }
	  if (ptr)
	    strcpy (remcomOutBuffer, "E02");
	  
	  break;
	  
	  /* cAA..AA    Continue at address AA..AA(optional) */
	  /* sAA..AA   Step one instruction from AA..AA(optional) */
	case 's':
	case 'c':
	  /* try, to read optional parameter, pc unchanged if no parm */
	  if (hexToInt (&ptr, &addr))
	    registers[PC] = addr;
	  return;
	  /* kill the program */
	case 'Z': // u[N|Cg̐ݒ
	  if(*ptr == '1'){//n[hEFAu[N|Cg
	    ptr ++;
	    if(*ptr == ','){
	      ptr ++;
	      if(hexToInt (&ptr, &addr)){
		if(*ptr == ','){
		  unsigned int *bkpt_addr;
		  // length͖B4oCĝ͂
		  bkpt_addr = &breakpoint_address;
		  *bkpt_addr = addr;
#ifdef UBC_SUPPORTED
		  UBC_set(addr);
		  strcpy (remcomOutBuffer, "OK");
#endif
		}
	      }
	    }
	  }
	  break;
	case 'z': // u[N|Cg̍폜
	  if(*ptr == '1'){//n[hEFAu[N|Cg
	    ptr ++;
	    if(*ptr == ','){
	      ptr ++;
	      if(hexToInt (&ptr, &addr)){
		if(*ptr == ','){
		  unsigned int *bkpt_addr;
		  // length͖B4oCĝ͂
		  bkpt_addr = &breakpoint_address;
		  *bkpt_addr = addr;
#ifdef UBC_SUPPORTED
		  UBC_clr();
#endif
		  strcpy (remcomOutBuffer, "OK");
		}
	      }
	    }
	  }
	  break;
	case 'k':		/* do nothing */
	case 'R':
	case 'r':
	  goto noreply;
	default:
	  break;
	}			/* switch */

      /* reply to the request */
      putpacket (remcomOutBuffer);
    noreply:
      continue;
    }
  return;
}


// ̊֐Oɂ΂AGDBɐԂB
void handle_exception(int exceptionVector)
{
  gdb_handle_exception (exceptionVector);
}

/**** Processor-specific routines start here ****/

#define	ulong unsigned long

// GDBgVA|[g܂B
// port_num01w肵ĂB
// 0̂ƂSCI0A1̂ƂSCI1g܂B
// baudrateɂ960019200w肷B
void init_serial (int port_num, int baudrate){
  volatile unsigned short *PACRL2;
  volatile unsigned char *SMR0,*BRR0,*SCR0,*TDR0,*SSR0,*RDR0,*SDCR0;
  volatile unsigned char *SMR1,*BRR1,*SCR1,*TDR1,*SSR1,*RDR1,*SDCR1;
  volatile unsigned short *MSTCR1;
  int i;

  MSTCR1 = (unsigned short *)0xFFFF861C;
  
  PACRL2 = (unsigned short *)0xFFFF838E;
  SMR0 = (unsigned char *)0xFFFF81A0;
  BRR0 = SMR0+1;
  SCR0 = SMR0+2;
  TDR0 = SMR0+3;
  SSR0 = SMR0+4;
  RDR0 = SMR0+5;
  SDCR0 = SMR0+6;

  SMR1 = (unsigned char *)0xFFFF81B0;
  BRR1 = SMR1+1;
  SCR1 = SMR1+2;
  TDR1 = SMR1+3;
  SSR1 = SMR1+4;
  RDR1 = SMR1+5;
  SDCR1 = SMR1+6;

  switch(port_num){
  case 1:
    // SCI1X^oCԂ
    *MSTCR1 &= ~0x2;
    // TXD1,RXD1Cl[u 
    *PACRL2 = ((1<<8) | (1<<6));
    // 8bit
    // peBȂ
    // Stoprbg1rbg
    *SCR1 = 0x0;
    *SMR1 = 0x0;
    if(baudrate == 9600)
      // 9600bps (CKS = 00, BRR=77)
      *BRR1 = 77;
    else if(baudrate == 19200)
      // 19200bps (CKS = 00, BRR=38)
      *BRR1 = 38;
    // 1rbg҂ԁiKɒ҂j
    for(i=0;i<(*BRR1*1000);i++){}
    // MAM
    *SCR1 = ((1<<5)|(1<<4));
    break;
  case 0:
    // SCI0X^oCԂ
    *MSTCR1 &= ~0x1;
    // TXD0,RXD0Cl[u 
    *PACRL2 |= ((1<<2) | (1<<0));
    // 8bit
    // peBȂ
    // Stoprbg1rbg
    *SCR0 = 0x0;
    *SMR0 = 0x0;
    if(baudrate == 9600)
      // 9600bps (CKS = 00, BRR=77)
      *BRR0 = 77;
    else if(baudrate == 19200)
      // 19200bps (CKS = 00, BRR=38)
      *BRR0 = 38;
    // 1rbg҂ԁiKɒ҂j
    for(i=0;i<(*BRR0*1000);i++){}
    // MAM
    *SCR0 = ((1<<5)|(1<<4));
    break;
  }
}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  volatile unsigned char *RDR0,*SSR0;
  volatile unsigned char *RDR1,*SSR1;
  char recv_char;

  switch(DEBUG_PORT_NUM){
  case 0:
    SSR0 = (unsigned char *)0xFFFF81A4;
    RDR0 = SSR0+1;
    
    while((*SSR0 & (1<<6)) == 0){}
    recv_char = *RDR0;
    *SSR0 &= ~(1<<6);
    break;    
  case 1:
    SSR1 = (unsigned char *)0xFFFF81B4;
    RDR1 = SSR1+1;
    
    while((*SSR1 & (1<<6)) == 0){}
    recv_char = *RDR1;
    *SSR1 &= ~(1<<6);
    break;
  }

  return recv_char;
}

// 1M֐B
void putDebugChar (char ch){
  volatile unsigned char *TDR0,*SSR0;
  volatile unsigned char *TDR1,*SSR1;

  switch(DEBUG_PORT_NUM){
  case 0:
    TDR0 = (unsigned char *)0xFFFF81A3;
    SSR0 = TDR0+1;

    // Mobt@̋󂫂҂
    while((*SSR0 & (1<<7)) == 0){}
    // Mf[^
    *TDR0 = ch;
    // MJn
    *SSR0 = *SSR0 & ~(1<<7);
    break;
  case 1:
    TDR1 = (unsigned char *)0xFFFF81B3;
    SSR1 = TDR1+1;
    
    // Mobt@̋󂫂҂
    while((*SSR1 & (1<<7)) == 0){}
    // Mf[^
    *TDR1 = ch;
    // MJn
    *SSR1 = *SSR1 & ~(1<<7);
    break;
  }  
}

void _illegalinst_func(void){
  unsigned int *bkpt_addr, *ilegal_addr;

  bkpt_addr = &breakpoint_address;
  ilegal_addr = &illegalinst_address;

  gdb_handle_exception(INVALID_INSN_VEC);
}

void _trap_func(void){
  unsigned int *bkpt_addr, *ilegal_addr;

  bkpt_addr = &breakpoint_address;
  ilegal_addr = &illegalinst_address;

  gdb_handle_exception(TRAP_VEC);
}

extern unsigned int sp_base;

#define DOWNLOAD_AREA_BASE 0xFFFFE000

// j^main[`
int main(){
  unsigned int *bkpt_addr, *ilegal_addr;
  int i;
    void (*target_main)();

  bkpt_addr = &breakpoint_address;
  ilegal_addr = &illegalinst_address;

  init_serial(DEBUG_PORT_NUM, DEBUG_BAUDRATE);

  *bkpt_addr = 0xFFFFFFFF;
  *ilegal_addr = 0;

  for(i=0;i<NUMREGS;i++)
    registers[i] = 0;

  registers[R15] = sp_base;
  registers[PC] = DOWNLOAD_AREA_BASE+0x400;

  while(1){
    gdb_handle_exception(TRAP_VEC);

    virtualVBR = 0x0;

    // _E[hX^[gAbv[`s
    target_main = (void *)(DOWNLOAD_AREA_BASE+0x400);
    target_main();
  }
  return 1;
}





